package edu.gatech.cercs.soa.core;


import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * Describe <code>DateUtils</code> here.
 * 
 * @author <a href="mailto:srihari@cc.gatech.edu">Hari Govindharaj</a>
 */
public class DateUtils {

   public static SimpleDateFormat defaultSDF;
   public static SimpleDateFormat timestampSDF;
   public static SimpleDateFormat standardSDF;

   static {
      defaultSDF = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
      timestampSDF = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS");
      standardSDF = new SimpleDateFormat("MM/dd/yyyy");
   }

   public static Date parse(String str, SimpleDateFormat sdf) {
      try {
         return sdf.parse(str);
      }
      catch (ParseException pe) {
         return new Date(0L);
      }
   }

   public static Date parseDefault(String str) {
      try {
         return defaultSDF.parse(str);
      }
      catch (ParseException pe) {
         return new Date(0L);
      }
   }

   public static String formatDefault(Date date) {
      return defaultSDF.format(date);
   }

   public static String formatTimestamp(Date date) {
      return timestampSDF.format(date);
   }

}
