package edu.gatech.cercs.soa.core;


import java.io.IOException;
import java.util.Properties;

/**
 * Describe <code>PropertyLoader</code> here.
 * 
 * @author <a href="mailto:srihari@cc.gatech.edu">Hari Govindharaj</a>
 */
public class PropertyLoader {

   private static PropertyLoader instance;
   private Properties properties;

   private PropertyLoader(String fileName) {
      try {
         properties = new Properties();
         properties.load(this.getClass().getClassLoader().getResourceAsStream(
                  fileName));
      }
      catch (IOException ex) {
         ex.printStackTrace();
      }
   }

   public static PropertyLoader getInstance(String fileName) {
      if (instance == null) {
         instance = new PropertyLoader(fileName);
      }
      return instance;
   }

   public String getValue(String key) {
      return (String) properties.get(key);
   }

   public int getIntValue(String key) {
       return Integer.parseInt((String)properties.get(key));
   }
   
   public long getLongValue(String key) {
       return Long.parseLong((String)properties.get(key));
   }
}
