package edu.gatech.cercs.soa.core.fpq;

import edu.gatech.cercs.soa.core.xml.XMLable;


/**
 * The IHeader interface provides access to the meta data for routing the 
 * flight pricing query.
 *
 * @author <a href="mailto:srihari@cc.gatech.edu">Hari Govindharaj</a>
 */
public interface IHeader extends XMLable {

    public static String QUERYMODE_POLL = "poll";
    public static String QUERYMODE_ASYNC = "async";
    
    public String getCustomerId();
    
    public void setCustomerId(String id);
    
    public String getQueryId();
    
    public void setQueryId(String id);

    public String getQueryMode();
    
    public void setQueryMode(String mode);
    
    public int getSearchId();
    
    public void setSearchId(int id);
    
    public long getTimestamp();
    
    public void setTimestamp(long ts);
    
    public int getExpiration();
    
    public void setExpiration(int exp);
    
}
