package edu.gatech.cercs.soa.core.fpq.impl;

import java.io.PrintWriter;
import java.util.*;

import org.xml.sax.Attributes;

import edu.gatech.cercs.soa.core.fpq.IAirlines;
import edu.gatech.cercs.soa.core.xml.XMLable;


/**
 * Describe <code>AirlinesImpl</code> here.
 *
 * @author <a href="mailto:srihari@cc.gatech.edu">Hari Govindharaj</a>
 */
public class AirlinesImpl implements IAirlines, XMLable {

    public List<String> airlines;
    
    public AirlinesImpl() {
        airlines = new ArrayList<String>();
    }
    
    public String[] getAirlines() {
        return airlines.toArray(new String[airlines.size()]);
    }

    public void setAirlines(String[] als) {
        airlines.clear();
        if (als != null) {
            for (int i = 0; i < als.length; i++) {
                airlines.add(als[i]);
            }
        }
    }

    ////////////////////////////////////////////////////////////////////////////
    // XMLable
    
    public void handleXMLCallback(String name, Attributes attrs,
            boolean isBeginElement, Map<String, Object> state) {
        if (isBeginElement) {
        }
        else {
            //Closing Tag
            if (name.equalsIgnoreCase("airline")) {
                String str = attrs.getValue("characters");
                if (str != null && str.length() > 0) {
                    airlines.add(str);
                }
            }
        }
    }

    public void saveAsXML(PrintWriter writer) {
        StringBuffer sb = new StringBuffer();
        sb.append("<Airlines>\n");
        for (Iterator<String> iter = airlines.iterator(); iter.hasNext();) {
            sb.append("<Airline>" + iter.next() + "</Airline>\n");
        }
        sb.append("</Airlines>\n");
        writer.write(sb.toString());
    }

}
