package edu.gatech.cercs.soa.core.fpq.impl;

import java.io.PrintWriter;
import java.util.Map;

import org.xml.sax.Attributes;

import edu.gatech.cercs.soa.core.fpq.IPassengers;
import edu.gatech.cercs.soa.core.xml.XMLable;


/**
 * Describe <code>PassengersImpl</code> here.
 *
 * @author <a href="mailto:srihari@cc.gatech.edu">Hari Govindharaj</a>
 */
public class PassengersImpl implements IPassengers, XMLable {

    private int adultCount;
    private int childCount;
    private int seniorCount;
    
    public int getAdultCount() {
        return adultCount;
    }

    public int getChildCount() {
        return childCount;
    }

    public int getSeniorCount() {
        return seniorCount;
    }

    public void setAdultCount(int count) {
        adultCount = count;
    }

    public void setChildCount(int count) {
        childCount = count;
    }

    public void setSeniorCount(int count) {
        seniorCount = count;
    }

    ////////////////////////////////////////////////////////////////////////////
    // XMLable 
    
    public void handleXMLCallback(String name, Attributes attrs,
            boolean isBeginElement, Map<String, Object> state) {
        if (isBeginElement) {
        }
        else {
            //Closing Tag
            String str = attrs.getValue("characters");
            if (name.equalsIgnoreCase("adult")) {
                adultCount = Integer.parseInt(str);
            }
            else if (name.equalsIgnoreCase("child")) {
                childCount = Integer.parseInt(str);
            }
            else if (name.equalsIgnoreCase("senior")) {
                seniorCount = Integer.parseInt(str);
            }
        }
    }

    public void saveAsXML(PrintWriter writer) {
        StringBuffer sb = new StringBuffer();
        sb.append("<Passengers>\n");
        sb.append("<Adult>" + adultCount + "</Adult>\n");
        sb.append("<Child>" + childCount + "</Child>\n");
        sb.append("<Senior>" + seniorCount + "</Senior>\n");
        sb.append("</Passengers>\n");
        writer.write(sb.toString());
    }

}
