package edu.gatech.cercs.soa.core.fpq.impl;

import java.io.PrintWriter;
import java.util.Date;
import java.util.Map;

import org.xml.sax.Attributes;

import edu.gatech.cercs.soa.core.DateUtils;
import edu.gatech.cercs.soa.core.fpq.ITrip;
import edu.gatech.cercs.soa.core.xml.XMLable;


/**
 * Describe <code>TripImpl</code> here.
 *
 * @author <a href="mailto:srihari@cc.gatech.edu">Hari Govindharaj</a>
 */
public class TripImpl implements ITrip, XMLable {

    private Date date;
    private String dest;
    private String orig;
    private boolean nonStop;
    
    public Date getDate() {
        return date;
    }

    public String getDestination() {
        return dest;
    }

    public String getOrigin() {
        return orig;
    }

    public boolean isNonStop() {
        return nonStop;
    }

    public void setDate(Date date) {
        this.date = date;
    }

    public void setDestination(String dest) {
        this.dest = dest;
    }

    public void setNonStop(boolean ns) {
        this.nonStop = ns;
    }

    public void setOrigin(String orig) {
        this.orig = orig;
    }

    ////////////////////////////////////////////////////////////////////////////
    // XMLable
    
    public void handleXMLCallback(String name, Attributes attrs,
            boolean isBeginElement, Map<String, Object> state) {
        if (isBeginElement) {
        }
        else {
            //Closing Tag
            String str = attrs.getValue("characters");
            if (name.equalsIgnoreCase("from")) {
                orig = str;
            }
            else if (name.equalsIgnoreCase("to")) {
                dest = str;
            }
            else if (name.equalsIgnoreCase("date")) {
                date = DateUtils.parseDefault(str);
            }
            else if (name.equalsIgnoreCase("nonstop")) {
                nonStop = str.equalsIgnoreCase("yes") ? true : false;
            }
        }
    }

    public void saveAsXML(PrintWriter writer) {
        StringBuffer sb = new StringBuffer();
        sb.append("<Trip>\n");
        sb.append("<From>" + orig + "</From>\n");
        sb.append("<To>" + dest + "</To>\n");
        sb.append("<Date>" + DateUtils.formatDefault(date) + "</Date>\n");
        sb.append("<NonStop>" + (nonStop ? "yes" : "no") + "</NonStop>\n");
        sb.append("</Trip>\n");
        writer.write(sb.toString());
    }

}