package edu.gatech.cercs.soa.core.fpr;

import edu.gatech.cercs.soa.core.xml.XMLable;


/**
 * The IHeaderResult interface provides access to the meta data for routing the 
 * flight pricing query result.
 *
 * @author <a href="mailto:srihari@cc.gatech.edu">Hari Govindharaj</a>
 */
public interface IHeaderResult extends XMLable {

    public static String QUERYMODE_POLL = "poll";
    public static String QUERYMODE_ASYNC = "async";
    
    public static String STATUS_NONE = "none";
    public static String STATUS_QUEUE = "queue";
    public static String STATUS_COMPLETE = "complete";
    public static String STATUS_ERROR = "error";
    public static String STATUS_ACKNOWLEDGE = "acknowledge";
    
    public String getCustomerId();
    
    public void setCustomerId(String id);
    
    public String getQueryId();
    
    public void setQueryId(String id);

    public String getQueryMode();
    
    public void setQueryMode(String mode);
    
    public int getSearchId();
    
    public void setSearchId(int id);
    
    public long getTimestamp();
    
    public void setTimestamp(long ts);
    
    public int getExpiration();
    
    public void setExpiration(int exp);
    
    public String getStatus();
    
    public void setStatus(String status);
 
    public String getStatusDetail();
    
    public void setStatusDetail(String detail);
    
}
