package edu.gatech.cercs.soa.core.fpr.impl;

import java.io.PrintWriter;
import java.util.Map;

import org.xml.sax.Attributes;

import edu.gatech.cercs.soa.core.fpr.IPriceResult;
import edu.gatech.cercs.soa.core.xml.XMLable;


/**
 * Describe <code>PriceResultImpl</code> here.
 *
 * @author <a href="mailto:srihari@cc.gatech.edu">Hari Govindharaj</a>
 */
public class PriceResultImpl implements IPriceResult, XMLable {

    private float fare;
    private float fee;
    private float tax;
    
    public float getFare() {
        return fare;
    }

    public float getFee() {
        return fee;
    }

    public float getTax() {
        return tax;
    }

    public void setFare(float fare) {
        this.fare = fare;
    }

    public void setFee(float fee) {
        this.fee = fee;
    }

    public void setTax(float tax) {
        this.tax = tax;
    }

    ////////////////////////////////////////////////////////////////////////////
    // XMLable
    
    public void handleXMLCallback(String name, Attributes attrs,
            boolean isBeginElement, Map<String, Object> state) {
        if (isBeginElement) {
        }
        else {
            //Closing Tag
            String str = attrs.getValue("characters");
            if (name.equalsIgnoreCase("fare")) {
                fare = Float.parseFloat(str);
            }
            else if (name.equalsIgnoreCase("tax")) {
                tax = Float.parseFloat(str);
            }
            else if (name.equalsIgnoreCase("fee")) {
                fee = Float.parseFloat(str);
            }
        }
    }

    public void saveAsXML(PrintWriter writer) {
        StringBuffer sb = new StringBuffer();
        sb.append("<Price>\n");
        sb.append("<Fare>" + fare + "</Fare>\n");
        sb.append("<Tax>" + tax + "</Tax>\n");
        sb.append("<Fee>" + fee + "</Fee>\n");
        sb.append("</Price>\n");
        writer.write(sb.toString());
    }

}
