package edu.gatech.cercs.soa.core.xml;


/**
 * Describe <code>XMLUtils</code> here.
 *
 * @author <a href="mailto:srihari@cc.gatech.edu">Hari Govindharaj</a>
 */
public class XMLUtils {

    /**
     * Returns an XML safe string, encoding
     *          "&" as "&amp;"
     *          "<" as "&lt;"
     *          ">" as "&gt;"
     *          "'" as "&apos;" (disabled)
     *          """ as "&quot;" (disabled)
     * as required for XML documents.
     */
    public static String encodeSafeString(String src) {
       if (src == null)
          return null;

       StringBuffer out = new StringBuffer(src.length());
       for (int i = 0; i < src.length(); i++) {
          int c = (int) src.charAt(i);
          switch (c) {
             case '&':
                out.append("&amp;");
                break;
             case '<':
                out.append("&lt;");
                break;
             case '>':
                out.append("&gt;");
                break;
//             case '\'':
//                out.append("&apos;");
//                break;
//             case '\"':
//                out.append("&quot;");
//                break;
             default:
                out.append((char)c);
          }
       }
       return out.toString();
    }


    public static String decodeSafeString(String src) {
    	return src == null ? "" : src.replaceAll("&amp;", "&").
          	replaceAll("&lt;", "<").
          	replaceAll("&gt;", ">").
          	replaceAll("&apos;", "'").
          	replaceAll("&quot", "\"");
    }
}
