package edu.gatech.cercs.soa.gds.web;

import java.rmi.Remote;
import java.rmi.RemoteException;


/**
 * Service endpoint interface for FlightPricingService.
 * 
 * @author <a href="mailto:srihari@cc.gatech.edu">Hari Govindharaj</a>
 */
public interface FlightPricingService extends Remote {

    /**
     * The searchPrices call submits the query string in XML format for GDS
     * processing.
     * @param query - non-null string in XML format
     * @return String - contains status info in XML format
     * @throws RemoteException
     */
    public String searchPrices(String query) throws RemoteException;

    /**
     * The retrieveResult call searches the flight pricing state table for the
     * query result.
     * @param queryId - non-null string
     * @return String - contains status info or query result in XML format
     * @throws RemoteException
     */
    public String retrieveResult(String customerId, String queryId) 
            throws RemoteException;
    
}
