package edu.gatech.cercs.soa.tws.web;

import java.rmi.RemoteException;


/**
 * The <code>TravelWebService</code> endpoint is used by clients to search the
 * travel web site for flight prices.
 *
 * @author <a href="mailto:srihari@cc.gatech.edu">Hari Govindharaj</a>
 */
public interface TravelWebService extends java.rmi.Remote {

   /**
    * The searchFlightPrices call submits the query string in XML format for the TWS
    * processing and returns the result immediately.
    * @param query - non-null string in XML format
    * @return String - contains search results in XML format
    * @throws RemoteException
    */
   public String searchFlightPrices(String fpquery) throws RemoteException;

   
   /**
    * The updateFlightPrices is invoked by the GDS service and submits the 
    * results of a flight pricing search query in XML format.
    * @param query - non-null string in XML format
    * @return String - contains acknowledgment in XML format
    * @throws RemoteException
    */
   public String updateFlightPrices(String fpresult) throws RemoteException;

}
